﻿Option Strict On
Option Explicit On

'Die DGVs sollen nur zeigen ob die Daten richtig geladen worden sind. Es gibt keine weitere Bindung

'Bei Form3 wird der Handler As EventHandler übergeben und sobald in Form3 der Buton2 geklickt wird, ein Event gefreuert,
'der dann in Form1 das Dataset mit Daten erweitert.
' ursprüngliche Quelle https://www.vb-paradise.de/index.php/Thread/125186-Form-%C3%BCbergreifendes-Databinding-an-ein-typisiertes-Dataset/?postID=1087414#post1087414


Public Class Form1
    Public TestClass As TestClass_neu
    Public Handler As EventHandler

    Public Sub New()
        MyBase.New()
        InitializeComponent()
        GlobalTds = Me.DataSet1
        LoadTestClass()

    End Sub

    Private Sub LoadTestClass() 'LoadTestClass() wird gleich vom Konstruktor aus ausgeführt
        TestClass = New TestClass_neu
        For i As Integer = 0 To 2 - 1
            SetDataIntoDataset()
        Next

        Me.DataGridView1.DataSource = GlobalTds.Wert 'Soll nur zeigen was drin ist
        Me.DataGridView2.DataSource = GlobalTds.NoiseSource 'Soll nur zeigen was drin ist
    End Sub

    Private Sub SetDataIntoDataset()
        With GlobalTds
            Dim cnt As Integer = .NoiseSource.Count
            .NoiseSource.AddNoiseSourceRow("Quelle" & cnt.ToString)
            .Wert.AddWertRow(cnt * 2, cnt * 2 * 11, .NoiseSource(cnt))
            .Wert.AddWertRow(cnt * 2 + 1, (cnt * 2 + 1) * 11, .NoiseSource(cnt))
        End With
    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button1.Click 'Einfach nur die Werte in Label1 auslesen.
        Dim OutputLines As New List(Of String)
        OutputLines.Clear()
        Dim cnt As Integer = GlobalTds.NoiseSource.Count

        For i As Integer = 0 To cnt - 1
            OutputLines.Add("----------------")
            For Each wert In GlobalTds.NoiseSource(i).GetWertRows
                OutputLines.Add(wert.Frequenz.ToString & "   " & wert.ENR_dB.ToString)
            Next
        Next
        OutputLines.Add("----------------")

        Label1.Text = (String.Join(Environment.NewLine, OutputLines))
    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button2.Click ' Werte mit MessageBox auslesen
        MessageBox.Show(TestClass.Infotext())
    End Sub

    Private Sub Button3_Click(ByVal sender As Object, ByVal e As EventArgs) Handles Button3.Click
        Using frm = New Form2(Me.TestClass)
            Dim result = frm.ShowDialog
        End Using

    End Sub


    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Handler = New EventHandler(AddressOf Form3_Event)
        Using frm = New Form3(Me.Handler)
            Dim result = frm.ShowDialog
        End Using
    End Sub

    Private Sub Form3_Event(ByVal sender As Object, ByVal e As EventArgs) ' Wenn der Event ausgelöst wird, wird diese Sub ausgeführt
        SetDataIntoDataset()
    End Sub


    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        Using frm = New Form4
            Dim result = frm.ShowDialog
        End Using
    End Sub
End Class



